#include "adam.h"

void Adam_Unit(fixed_type Weights[1], fixed_type Grad[1], fixed_type mt[1], fixed_type vt_root[1]){
	double test;
	fixed_type current_mt, current_vt_root, mt_a, mt_b;
	fixed_type tmp = mt[0];

	current_mt = tmp + (Grad[0] - tmp) >> 3;
	float mt_test = current_mt;
	fixed_type a,b,abs;

	// Calculate the absolute value of G
	if (Grad[0] > 0){
		abs = Grad[0];
	}
	else abs = -Grad[0];

	a = abs >> 5;  // a = sqrt(1 - B2) * |G| = sqrt(2^(-10)) * |G| = abs >> 5
	float a_test = a;
	float vt_root_test = vt_root[0];
	b = (vt_root[0]) * fixed_type(0.995115995); // b = sqrt(B2) * vt_root[i][j]
	float b_test = b;

	// Find the a(bigger one) and b(smaller one)
	if(a < b){
		fixed_type exchange = a;
		a = b;
		b = exchange;
	}

	current_vt_root = a + (b >> 2) + (b >> 4)  + (b >> 6) + (b >> 8) + fixed_type(MIN_NUMBER);
	float vt_test = current_vt_root;

	fixed_type vt_root_inverse = Inverse_FixedInput_Fixed_0313(current_vt_root);

	fixed_type dir;
	dir = current_mt * vt_root_inverse;

	dir = dir >> 2;

	test = dir;
	mt[0] = current_mt;
	vt_root[0] = current_vt_root;
	Weights[0] = Weights[0] - (dir >> 6);  // shift right 6bits for learning rate 0.015625
}

void my_adam(fixed_type Weights[2][1], fixed_type Grad[2][1], fixed_type mt[2][1], fixed_type vt_root[2][1]){
#pragma HLS INTERFACE s_axilite port=return
#pragma HLS INTERFACE m_axi depth=2 port=Grad offset=slave
#pragma HLS INTERFACE m_axi depth=2 port=Weights offset=slave
#pragma HLS INTERFACE m_axi depth=2 port=mt offset=slave
#pragma HLS INTERFACE m_axi depth=2 port=vt_root offset=slave

	fixed_type Weights_buffer[2][1];
	fixed_type Grad_buffer[2][1];
	fixed_type mt_buffer[2][1];
	fixed_type vt_root_buffer[2][1];

	for (int i=0; i<2; i++){
		Weights_buffer[i][0] = Weights[i][0];
		Grad_buffer[i][0] = Grad[i][0];
		mt_buffer[i][0] = mt[i][0];
		vt_root_buffer[i][0] = vt_root[i][0];
	}

	for (int i=0; i<2; i++){
#pragma HLS UNROLL factor=2
		Adam_Unit(Weights_buffer[i],Grad_buffer[i],mt_buffer[i],vt_root_buffer[i]);
	}

	for (int i=0; i<2; i++){
		Weights[i][0] = Weights_buffer[i][0];
		Grad[i][0] = Grad_buffer[i][0];
		mt[i][0] = mt_buffer[i][0];
		vt_root[i][0] = vt_root_buffer[i][0];
	}

}

fixed_type Inverse_FixedInput_Fixed_0313(fixed_type number){
	long i;
	float y;
	y = number;

	i = * (ap_uint<32> *) &y;
	i = 0x7ef477d3 - i;

	y = *(float *) &i;

	fixed_type y_fixed = y;

	fixed_type tmp1, tmp2;
	tmp1 = y_fixed * number;

	tmp2 = tmp1 * y_fixed;

	tmp1 = y_fixed + y_fixed - tmp2;

	return tmp1;
}
